# q

A programming language that compiles down to machine code.

## Features

- Fast compilation
- High performance
- Small executables
- Zero dependencies

## Installation

```shell
git clone https://git.akyoto.dev/cli/q
cd q
go build
```

Either use `./q` from the build directory or get access to the shorter `q` in any directory with `ln -s $PWD/q ~/.local/bin/q`.

## Usage

```shell
q run examples/hello
```

You can take a look at the [examples](../examples).

## Tests

```shell
go run gotest.tools/gotestsum@latest
```

This will run over 350 tests in various categories.

## Platforms

You can cross-compile executables for Linux, Mac and Windows.

```shell
q build examples/hello --os linux
q build examples/hello --os mac
q build examples/hello --os windows
```

## Status

`q` is under heavy development and not ready for production yet.
Feel free to [get in touch](https://akyoto.dev/contact) if you are interested in helping out.

The biggest obstacle right now is the lack of funding. If you want to help out financially you can [donate towards the project](https://en.liberapay.com/akyoto).

## License

Please see the [license documentation](https://akyoto.dev/license).

## Copyright

© 2023 Eduard Urbach
